package nl.utwente.di.bookQuote;

import java.io.*;
import jakarta.servlet.*;
import jakarta.servlet.http.*;
import java.util.HashMap;

/**
 * Example of a Servlet that gets an ISBN number and returns the book price
 */

public class BookQuote extends HttpServlet {
    /**
     *
     */
    private static final long serialVersionUID = 1L;
    private Quoter quoter;

    public void init() throws ServletException {
        quoter = new Quoter();
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        String title = "Book Quote";

        // Done with string concatenation only for the demo
        // Not expected to be done like this in the project

        //**This is for the bookprices! **//
        //        out.println(
        //                "<!DOCTYPE HTML>\n" + "<HTML>\n" + "<HEAD><TITLE>" + title + "</TITLE>" + "<LINK REL=STYLESHEET HREF=\"styles.css\">" + "</HEAD>\n" + "<BODY BGCOLOR=\"#FDF5E6\">\n" + "<H1>" + title + "</H1>\n" + "  <P>ISBN number: " + request.getParameter(
        //                        "isbn") + "\n" + "  <P>Price: " + quoter.getBookPrice(
        //                        request.getParameter("isbn")) + "</BODY></HTML>");

        out.println(
                "<!DOCTYPE HTML>\n" + "<HTML>\n" + "<HEAD><TITLE>" + title + "</TITLE>" + "<LINK REL=STYLESHEET HREF=\"styles.css\">" + "</HEAD>\n" + "<BODY BGCOLOR=\"#FDF5E6\">\n" + "<H1>" + title + "</H1>\n" + "  <P>degrees in celsius: " + request.getParameter(
                        "degrees") + "\n" + "  <P>Fahrenheit: " + quoter.getFahrenheit(
                        request.getParameter("degrees")) + "</BODY></HTML>");
    }


    public static class Quoter {

        private final HashMap<String, Double> books = new HashMap<>() {{
            put("1", 10.0);
            put("2", 45.0);
            put("3", 20.0);
            put("4", 35.0);
            put("5", 50.0);
        }};

        public float getFahrenheit(String degrees) {
            try {
                return (Integer.valueOf(degrees) * 9 / 5) + 32;
            } catch (NumberFormatException nfe) {
                return 0;
            }
        }

        public double getBookPrice(String isbn) {
            if (books.containsKey(isbn)) {
                return books.get(isbn);
            }
            return 0;
        }
    }

}
